/* common for c2txt and txt2c */

#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "x2x.h"

int yyerror(char *str)
{
  puts(str);
  return 0;
}

struct names_st
{
  char *name,*id,*ntype;
} *names=NULL;
int names_count;

char *C_txt,*C_add;

//return name or exits
char *add_name(char *name)
{
  if(names_count>=MAX_NAMES) {
    fprintf(stderr,"MAX_NAMES too small\n");
    exit(-1);
  }
  names[names_count].id=NULL;
  return names[names_count++].name=strdup(name);
}

char *get_id(char *name)
{
  int i;
  for(i=0;i<names_count && names[i].id;i++) 
    if(strcmp(names[i].name,name)==0) return names[i].id;
  fprintf(stderr,"get_name: Ooops: id not found for name %s\n",name);
  exit(-1);
  return NULL;
}

char *get_name(char *id)
{
  int i;
  for(i=0;i<names_count && names[i].id;i++) 
    if(strcmp(names[i].id,id)==0) return names[i].name;
  fprintf(stderr,"get_name: Ooops: name not found for id %s\n",id);
  exit(-1);
  return NULL;
}

char *get_type(char *id)
{
  int i;
  for(i=0;i<names_count && names[i].id;i++) 
    if(strcmp(names[i].id,id)==0) return names[i].ntype;
  fprintf(stderr,"get_type: Ooops: name not found for id %s\n",id);
  exit(-1);
  return NULL;
}

// returns name that corresponds to id
char *add_id(char *id, char *ntype)
{
  int i;
  for(i=0;i<names_count;i++) {
    if(!names[i].id) {
      names[i].id=strdup(id);
      names[i].ntype=strdup(ntype);
      D(printf("added:%s",id));
      return names[i].name;
    } else if(strcmp(names[i].id,id)==0) {
      if(strcmp(names[i].ntype,ntype)) {
        D(printf("different types: id=%s, %s -> %s",id,names[i].ntype,ntype));
        free(names[i].ntype);
        names[i].ntype=strdup(ntype);
      }
      return names[i].name;
    }
  }
  fprintf(stderr,"Not enough names\n");
  exit(-1);
  return NULL;
}

int read_names(char *file_name)
{
#define NAME_LEN 100
  int i;
  char str[NAME_LEN];
  FILE *fp=fopen(file_name,"r");
  if(!fp) {
    if(!fp) perror(file_name);
    return -1;
  }
  names=malloc(sizeof(names[0])*MAX_NAMES);
  names_count=0;

  while(fgets(str,NAME_LEN,fp)) {
    i=strlen(str);
    if(i>0 && str[i-1]=='\n') str[i-1]=0;
    add_name(str);
  }
  fclose(fp);
  return 0;
}  

#if DEBUG
char *debStr;
#endif

char *nstr2hexstr(char *num_str)
{
  static char str[20];
  sprintf(str,"0x%08lx",strtoul(num_str,NULL,10));
  return str;
}

char *hex2nstr(char *hex_str)
{
  int len=strlen(hex_str);
  unsigned long int n;
  static char hex_buffer[13];
  if(len<3) return NULL;
  if(hex_str[len-1]=='l') hex_str[len-1]=0;
  n=strtoul(hex_str,NULL,16);
  sprintf(hex_buffer,"%lu",n);
  return hex_buffer;
}

